#!/usr/bin/perl 


@tablefont = [];
@tableproc = [];
$nb_labels = 0;

sub traite_label {
    my ($label_tex, @tablefont) = @_;
    local ($process, $tex_file, $dvi_file, $ps_file, $tmp_file, $label_ps, $dim_label,
        $BBline, $lx, $ly, $ux, $uy, $log_file, $tex, $latex, $i);
    $process = $$;

    ## TeX ou LaTeX ?
    if ($label_tex =~ /<tex>/) {
        $tex = 1;
        $latex = 0;
    }
    if ($label_tex =~ /<latex>/) {
        $tex = 0;
        $latex = 1;
    }

    ## les fichiers temporaires
    $TMP_DIR = "/tmp/";
    $tex_file = $TMP_DIR . "tex" . $process . ".tex";
    $aux_file = $TMP_DIR . "tex" . $process . ".aux";
    $dvi_file = $TMP_DIR . "tex" . $process . ".dvi";
    $ps_file = $TMP_DIR . "tex" . $process . ".ps";
    $log_file = $TMP_DIR . "tex" . $process . ".log";
    $tmp_file = $TMP_DIR . "bof" . $process . ".ps";

    ## compilation TeX
    if ($tex) {
        $label_tex =~ s/<tex>.*\n//;
        $label_tex =~ s/<\/tex>.*\n//;
        $format = $JPS2PS_DIR . "jps.tex";
        open (TEX, ">$tex_file") or die "impossible d'ouvrir $tex_file";
        print (TEX "\\input $format\n");
        print (TEX "\\vtop {\\tvi $label_tex}\n");
        print (TEX "\\vfill\n");
        print (TEX "\\eject \\bye\n");
        close (TEX);
        `cd $TMP_DIR \; tex $tex_file`;
    }

    ## compilation LaTeX
    if ($latex) {
        $label_tex =~ s/<latex>.*\n//;
        $label_tex =~ s/<\/latex>.*\n//;
        open (TEX, ">$tex_file") or die "impossible d'ouvrir $tex_file";
        print (TEX "\\documentclass{article}\n");
        print (TEX "\\usepackage[francais]{babel}\n");
        print (TEX "\\usepackage[T1]{fontenc}\n");
        print (TEX "\\usepackage{amsfonts,amssymb}\n");
        print (TEX "\\begin{document}\n");
        print (TEX "\\pagestyle{empty}\n");
        print (TEX "\\parindent=0cm\n");
        print (TEX $label_tex);
        print (TEX "\\end{document}\n");
        close (TEX);
        `cd $TMP_DIR \; latex $tex_file`;
        `rm $aux_file`;
    }
        
    ## on prepare le fichier ps
    `cd $TMP_DIR \; dvips -E -Pcmz -Pamz -j0 $dvi_file -o $ps_file`;

##     ## pour deboguer
##     print (STDOUT "DEBUT\n");
##     $i = $#tablefont;
##     while ($i > 0) {
## 	   print (STDOUT "i = $i , $tablefont[$i]\n");
## 	   $i--;
##     }

##     ## maintenant, on filtre pour enlever les procedures que l'on a deja
##     $i = $#tableproc;
##     print (STDOUT "passage proc $i\n");
##     while ($i > 0) {
##         $proc = $tableproc[$i];
##         print (STDOUT "passage proc : $proc ...\n");
##         `cat $ps_file | $filtre '$proc' '%%EndProcSet' > $ps_file`;
##         $i--;
##     }

##     ## on note les procedures supplementaires qui restent
##     @newtableproc = `cat $ps_file | grep "BeginProcSet"|sort|uniq`;
##     print (STDOUT "BAOUM\n");
##     $i = 0;
##     foreach $proc (@newtableproc) {
## 	   $newtableproc[$i] =~ s/\n//;
## 	   print (STDOUT "$newtableproc[$i]\n");
## 	   $i++;
##     }
##     push (@tableproc, @newtableproc);

    ## maintenant, on filtre pour enlever les fontes que l'on a deja
    $i = $#tablefont;
##    print (STDOUT "passage font $i\n");
    while ($i > 0) {
        $font = $tablefont[$i];
##        print (STDOUT "passage font : $font ...\n");
        `cat $ps_file | $filtre '$font' '%%EndFont' > $tmp_file`;
        `mv $tmp_file $ps_file`;
        $i--;
    }

    ## on note les fontes supplementaires qui restent
    @newtablefont = `cat $ps_file | grep "BeginFont"|sort|uniq`;
    $i = 0;
    foreach $font (@newtablefont) {
	$newtablefont[$i] =~ s/\n//;
##	print (STDOUT "$newtablefont[$i]\n");
	$i++;
    }
    push (@tablefont, @newtablefont);

##     print (STDOUT "FINAL\n");
##     $i = $#tablefont;
##     while ($i > 0) {
## 	   print (STDOUT "i = $i , $tablefont[$i]\n");
## 	   $i--;
##     }

    ## maintenant il faut lire le fichier ps extraire les infos, et faire les modifs
    $BBline = `cat $ps_file | grep "%%BoundingBox:"`;
    $BBline =~ s/%%BoundingBox: //;

    ($lx, $ly, $ux, $uy) = split (/ /, $BBline);

    $nb_lignes = `cat $ps_file | wc -l`;
    $nb_lignes =~ s/[ \n]//g;
    $nb_lignes = $nb_lignes - 11;

    $resultat = `cat $ps_file | tail -n $nb_lignes`;
    $resultat =~ s/showpage/{}/s;

    $oppose_lx = -$lx;
    $oppose_ly = -$ly;
    
    if ($latex) {
        $lx = $lx - 133;
        $ux = $ux - 133;
        $ly = $ly - 656;
        $uy = $uy - 656;
    } else { 
    	$lx = $lx - 71;
    	$ux = $ux - 71;
    	$ly = $ly - 600;
    	$uy = $uy - 600;
    }

    ## on definit la nouvelle commande 'label'
    if ($resultat =~ /%%EndFont *\nTeXDict begin /) {
##      print (STDOUT "passage EndFont\nTeXDict begin ");
        $resultat =~ s/(%%EndFont *\n)(TeXDict begin )/$1\/label$nb_labels {\n$2/s;
        $resultat =~ s/%%EndSetup\n/%%EndSetup\n $oppose_lx $oppose_ly translate\n/s;
        $resultat =~ s/%%EOF/} def \/label {label$nb_labels} def/s;
    } else {
##      print (STDOUT "passage TeXDict\n");
        $resultat =~ s/(TeXDict begin .*\nTeXDict begin *\n)/\/label$nb_labels {\n$1/sg;
        $resultat =~ s/%%EndSetup\n/%%EndSetup\n $oppose_lx $oppose_ly translate\n/s;
        $resultat =~ s/%%EOF/} def \/label {label$nb_labels} def/s;
   } ;

    $wx = $ux-$lx;
    $wy = $uy-$ly;
## on definit les nouvelles valeurs des constantes 
    $BBline = "/dim_label {$wx $wy} bind def
   /lx $lx def
   /ly $ly def
   /ux $ux def
   /uy $uy def
   /dim_label$nb_labels {
   /lx $lx def
   /ly $ly def
   /ux $ux def
   /uy $uy def
   } def\n";

   ## le nettoyage final
   `rm $tex_file`;
   `rm $dvi_file`;
   `rm $ps_file`;
   `rm $log_file`;
#   `rm $tmp_file`;
    $nb_labels++;
    return ($resultat, $BBline, @tablefont);
};

1;
